Index: uspace/lib/net/generic/packet_client.c
===================================================================
--- uspace/lib/net/generic/packet_client.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
+++ uspace/lib/net/generic/packet_client.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -0,0 +1,294 @@
+/*
+ * Copyright (c) 2009 Lukas Mejdrech
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libnet
+ * @{
+ */
+
+/** @file
+ * Packet client implementation.
+ */
+
+#include <errno.h>
+#include <mem.h>
+#include <unistd.h>
+#include <sys/mman.h>
+
+#include <packet_client.h>
+#include <packet_remote.h>
+
+#include <net/packet.h>
+#include <net/packet_header.h>
+
+/** Copies the specified data to the beginning of the actual packet content.
+ *
+ * Pushes the content end if needed.
+ *
+ * @param[in] packet	The packet to be filled.
+ * @param[in] data	The data to be copied.
+ * @param[in] length	The length of the copied data.
+ * @returns		EOK on success.
+ * @returns		EINVAL if the packet is not valid.
+ * @returns		ENOMEM if there is not enough memory left.
+ */
+int packet_copy_data(packet_t packet, const void *data, size_t length)
+{
+	if (!packet_is_valid(packet))
+		return EINVAL;
+
+	if (packet->data_start + length >= packet->length)
+		return ENOMEM;
+
+	memcpy((void *) packet + packet->data_start, data, length);
+	if (packet->data_start + length > packet->data_end) 
+		packet->data_end = packet->data_start + length;
+
+	return EOK;
+}
+
+/** Allocates the specified space right before the actual packet content and
+ * returns its pointer.
+ *
+ * @param[in] packet	The packet to be used.
+ * @param[in] length	The space length to be allocated at the beginning of the
+ *			packet content.
+ * @returns		The pointer to the allocated memory.
+ * @returns		NULL if there is not enough memory left.
+ */
+void *packet_prefix(packet_t packet, size_t length)
+{
+	if ((!packet_is_valid(packet)) ||
+	    (packet->data_start - sizeof(struct packet) -
+	    2 * (packet->dest_addr - packet->src_addr) < length)) {
+		return NULL;
+	}
+
+	packet->data_start -= length;
+	return (void *) packet + packet->data_start;
+}
+
+/** Allocates the specified space right after the actual packet content and
+ * returns its pointer.
+ *
+ * @param[in] packet	The packet to be used.
+ * @param[in] length	The space length to be allocated at the end of the
+ *			 packet content.
+ * @returns		The pointer to the allocated memory.
+ * @returns		NULL if there is not enough memory left.
+ */
+void *packet_suffix(packet_t packet, size_t length)
+{
+	if ((!packet_is_valid(packet)) ||
+	    (packet->data_end + length >= packet->length)) {
+		return NULL;
+	}
+
+	packet->data_end += length;
+	return (void *) packet + packet->data_end - length;
+}
+
+/** Trims the actual packet content by the specified prefix and suffix lengths.
+ *
+ * @param[in] packet	The packet to be trimmed.
+ * @param[in] prefix	The prefix length to be removed from the beginning of
+ *			the packet content.
+ * @param[in] suffix	The suffix length to be removed from the end of the
+ *			packet content.
+ * @returns		EOK on success.
+ * @returns		EINVAL if the packet is not valid.
+ * @returns		ENOMEM if there is not enough memory left.
+ */
+int packet_trim(packet_t packet, size_t prefix, size_t suffix)
+{
+	if (!packet_is_valid(packet))
+		return EINVAL;
+
+	if (prefix + suffix > PACKET_DATA_LENGTH(packet))
+		return ENOMEM;
+
+	packet->data_start += prefix;
+	packet->data_end -= suffix;
+	return EOK;
+}
+
+/** Returns the packet identifier.
+ *
+ * @param[in] packet	The packet.
+ * @returns		The packet identifier.
+ * @returns		Zero if the packet is not valid.
+ */
+packet_id_t packet_get_id(const packet_t packet)
+{
+	return packet_is_valid(packet) ? packet->packet_id : 0;
+}
+
+/** Returns the stored packet addresses and their length.
+ *
+ * @param[in] packet	The packet.
+ * @param[out] src	The source address. May be NULL if not desired.
+ * @param[out] dest	The destination address. May be NULL if not desired.
+ * @returns		The stored addresses length.
+ * @returns		Zero if the addresses are not present.
+ * @returns		EINVAL if the packet is not valid.
+ */
+int packet_get_addr(const packet_t packet, uint8_t **src, uint8_t **dest)
+{
+	if (!packet_is_valid(packet))
+		return EINVAL;
+	if (!packet->addr_len)
+		return 0;
+	if (src)
+		*src = (void *) packet + packet->src_addr;
+	if (dest)
+		*dest = (void *) packet + packet->dest_addr;
+
+	return packet->addr_len;
+}
+
+/** Returns the packet content length.
+ *
+ * @param[in] packet	The packet.
+ * @returns		The packet content length in bytes.
+ * @returns		Zero if the packet is not valid.
+ */
+size_t packet_get_data_length(const packet_t packet)
+{
+	if (!packet_is_valid(packet))
+		return 0;
+
+	return PACKET_DATA_LENGTH(packet);
+}
+
+/** Returns the pointer to the beginning of the packet content.
+ *
+ * @param[in] packet	The packet.
+ * @returns		The pointer to the beginning of the packet content.
+ * @returns		NULL if the packet is not valid.
+ */
+void *packet_get_data(const packet_t packet)
+{
+	if (!packet_is_valid(packet))
+		return NULL;
+
+	return (void *) packet + packet->data_start;
+}
+
+/** Sets the packet addresses.
+ *
+ * @param[in] packet	The packet.
+ * @param[in] src	The new source address. May be NULL.
+ * @param[in] dest	The new destination address. May be NULL.
+ * @param[in] addr_len	The addresses length.
+ * @returns		EOK on success.
+ * @returns		EINVAL if the packet is not valid.
+ * @returns		ENOMEM if there is not enough memory left.
+ */
+int
+packet_set_addr(packet_t packet, const uint8_t *src, const uint8_t *dest,
+    size_t addr_len)
+{
+	size_t padding;
+	size_t allocated;
+
+	if (!packet_is_valid(packet))
+		return EINVAL;
+
+	allocated = PACKET_MAX_ADDRESS_LENGTH(packet);
+	if (allocated < addr_len)
+		return ENOMEM;
+
+	padding = allocated - addr_len;
+	packet->addr_len = addr_len;
+
+	if (src) {
+		memcpy((void *) packet + packet->src_addr, src, addr_len);
+		if (padding)
+			bzero((void *) packet + packet->src_addr + addr_len,
+			    padding);
+	} else {
+		bzero((void *) packet + packet->src_addr, allocated);
+	}
+
+	if (dest) {
+		memcpy((void *) packet + packet->dest_addr, dest, addr_len);
+		if (padding)
+			bzero((void *) packet + packet->dest_addr + addr_len,
+			    padding);
+	} else {
+		bzero((void *) packet + packet->dest_addr, allocated);
+	}
+
+	return EOK;
+}
+
+/** Returns the packet copy.
+ *
+ * Copies the addresses, data, order and metric values.
+ * Does not copy the queue placement.
+ *
+ * @param[in] phone	The packet server module phone.
+ * @param[in] packet	The original packet.
+ * @returns		The packet copy.
+ * @returns		NULL on error.
+ */
+packet_t packet_get_copy(int phone, packet_t packet)
+{
+	packet_t copy;
+	uint8_t * src = NULL;
+	uint8_t * dest = NULL;
+	size_t addrlen;
+
+	if (!packet_is_valid(packet))
+		return NULL;
+
+	// get a new packet
+	copy = packet_get_4_remote(phone, PACKET_DATA_LENGTH(packet),
+	    PACKET_MAX_ADDRESS_LENGTH(packet), packet->max_prefix,
+	    PACKET_MIN_SUFFIX(packet));
+	if (!copy)
+		return NULL;
+
+	// get addresses
+	addrlen = packet_get_addr(packet, &src, &dest);
+	// copy data
+	if ((packet_copy_data(copy, packet_get_data(packet),
+	    PACKET_DATA_LENGTH(packet)) == EOK) &&
+	    // copy addresses if present
+	    ((addrlen <= 0) ||
+	    (packet_set_addr(copy, src, dest, addrlen) == EOK))) {
+		copy->order = packet->order;
+		copy->metric = packet->metric;
+		return copy;
+	} else {
+		pq_release_remote(phone, copy->packet_id);
+		return NULL;
+	}
+}
+
+/** @}
+ */
Index: uspace/lib/net/generic/packet_remote.c
===================================================================
--- uspace/lib/net/generic/packet_remote.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ uspace/lib/net/generic/packet_remote.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -27,25 +27,25 @@
  */
 
-/** @addtogroup packet
- *  @{
+/** @addtogroup libnet
+ * @{
  */
 
 /** @file
- *  Packet client interface implementation for remote modules.
- *  @see packet_client.h
+ * Packet client interface implementation for remote modules.
+ * @see packet_client.h
  */
 
 #include <async.h>
 #include <errno.h>
+#include <err.h>
 #include <ipc/ipc.h>
+#include <ipc/packet.h>
 #include <sys/mman.h>
 
-#include <net_err.h>
-#include <net_messages.h>
-#include <packet/packet.h>
-#include <packet/packet_client.h>
-#include <packet/packet_header.h>
-#include <packet/packet_messages.h>
+#include <packet_client.h>
 #include <packet_remote.h>
+
+#include <net/packet.h>
+#include <net/packet_header.h>
 
 /** Obtain the packet from the packet server as the shared memory block.
@@ -64,12 +64,15 @@
  *
  */
-static int packet_return(int phone, packet_ref packet, packet_id_t packet_id, size_t size){
+static int
+packet_return(int phone, packet_ref packet, packet_id_t packet_id, size_t size)
+{
 	ERROR_DECLARE;
 	
 	ipc_call_t answer;
 	aid_t message = async_send_1(phone, NET_PACKET_GET, packet_id, &answer);
+
 	*packet = (packet_t) as_get_mappable_page(size);
-	if (ERROR_OCCURRED(async_share_in_start_0_0(phone, *packet, size))
-	    || ERROR_OCCURRED(pm_add(*packet))) {
+	if (ERROR_OCCURRED(async_share_in_start_0_0(phone, *packet, size)) ||
+	    ERROR_OCCURRED(pm_add(*packet))) {
 		munmap(*packet, size);
 		async_wait_for(message, NULL);
@@ -83,4 +86,19 @@
 }
 
+/** Translates the packet identifier to the packet reference.
+ *
+ * Tries to find mapping first.
+ * Contacts the packet server to share the packet if the mapping is not present.
+ *
+ * @param[in] phone	The packet server module phone.
+ * @param[out] packet	The packet reference.
+ * @param[in] packet_id	The packet identifier.
+ * @returns		EOK on success.
+ * @returns		EINVAL if the packet parameter is NULL.
+ * @returns		Other error codes as defined for the NET_PACKET_GET_SIZE
+ *			message.
+ * @returns		Other error codes as defined for the packet_return()
+ *			function.
+ */
 int packet_translate_remote(int phone, packet_ref packet, packet_id_t packet_id)
 {
@@ -91,14 +109,15 @@
 	
 	*packet = pm_find(packet_id);
-	if (!(*packet)) {
+	if (!*packet) {
 		ipcarg_t size;
 		
-		ERROR_PROPAGATE(async_req_1_1(phone, NET_PACKET_GET_SIZE, packet_id, &size));
+		ERROR_PROPAGATE(async_req_1_1(phone, NET_PACKET_GET_SIZE,
+		    packet_id, &size));
 		ERROR_PROPAGATE(packet_return(phone, packet, packet_id, size));
 	}
-	if ((** packet).next) {
+	if ((*packet)->next) {
 		packet_t next;
 		
-		return packet_translate_remote(phone, &next, (** packet).next);
+		return packet_translate_remote(phone, &next, (*packet)->next);
 	}
 	
@@ -106,4 +125,17 @@
 }
 
+/** Obtains the packet of the given dimensions.
+ *
+ * Contacts the packet server to return the appropriate packet.
+ *
+ * @param[in] phone	The packet server module phone.
+ * @param[in] addr_len	The source and destination addresses maximal length in
+ *			bytes.
+ * @param[in] max_prefix The maximal prefix length in bytes.
+ * @param[in] max_content The maximal content length in bytes.
+ * @param[in] max_suffix The maximal suffix length in bytes.
+ * @returns		The packet reference.
+ * @returns		NULL on error.
+ */
 packet_t packet_get_4_remote(int phone, size_t max_content, size_t addr_len,
     size_t max_prefix, size_t max_suffix)
@@ -114,6 +146,6 @@
 	ipcarg_t size;
 	
-	if (ERROR_OCCURRED(async_req_4_2(phone, NET_PACKET_CREATE_4, max_content,
-	    addr_len, max_prefix, max_suffix, &packet_id, &size)))
+	if (ERROR_OCCURRED(async_req_4_2(phone, NET_PACKET_CREATE_4,
+	    max_content, addr_len, max_prefix, max_suffix, &packet_id, &size)))
 		return NULL;
 	
@@ -121,5 +153,6 @@
 	packet_t packet = pm_find(packet_id);
 	if (!packet) {
-		if (ERROR_OCCURRED(packet_return(phone, &packet, packet_id, size)))
+		if (ERROR_OCCURRED(packet_return(phone, &packet, packet_id,
+		    size)))
 			return NULL;
 	}
@@ -128,4 +161,13 @@
 }
 
+/** Obtains the packet of the given content size.
+ *
+ * Contacts the packet server to return the appropriate packet.
+ *
+ * @param[in] phone	The packet server module phone.
+ * @param[in] content	The maximal content length in bytes.
+ * @returns		The packet reference.
+ * @returns		NULL on error.
+ */
 packet_t packet_get_1_remote(int phone, size_t content)
 {
@@ -141,5 +183,6 @@
 	packet_t packet = pm_find(packet_id);
 	if (!packet) {
-		if (ERROR_OCCURRED(packet_return(phone, &packet, packet_id, size)))
+		if (ERROR_OCCURRED(packet_return(phone, &packet, packet_id,
+		    size)))
 			return NULL;
 	}
@@ -148,4 +191,14 @@
 }
 
+/** Releases the packet queue.
+ *
+ * All packets in the queue are marked as free for use.
+ * The packet queue may be one packet only.
+ * The module should not use the packets after this point until they are
+ * received or obtained again.
+ *
+ * @param[in] phone	The packet server module phone.
+ * @param[in] packet_id	The packet identifier.
+ */
 void pq_release_remote(int phone, packet_id_t packet_id)
 {
